import { fileURLToPath, URL } from 'node:url'

import { defineConfig } from 'vite'
import vue from '@vitejs/plugin-vue'
import vueJsx from '@vitejs/plugin-vue-jsx'

// https://vitejs.dev/config/
export default defineConfig({
  plugins: [
    vue(),
    vueJsx(),
  ],
  resolve: {
    alias: {
      '@': fileURLToPath(new URL('./src', import.meta.url))
    }
  },
  server: {
    proxy: {
      '/server.Runner': {
        target: 'http://127.0.0.1:8080',
        changeOrigin: true,
      },
      '/browser': {
        target: 'http://127.0.0.1:8080',
        changeOrigin: true,
      },
      '/v3': {
        target: 'http://127.0.0.1:8080',
        changeOrigin: true,
      },
    },
  },
})
